//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property  copyright "www.forex-tsd.com"
#property  link      "www.forex-tsd.com"

#property  indicator_separate_window
#property  indicator_buffers 5
#property  indicator_color1  DeepSkyBlue
#property  indicator_color2  DeepSkyBlue
#property  indicator_color3  PaleVioletRed
#property  indicator_color4  PaleVioletRed
#property  indicator_color5  Silver
#property  indicator_width1  2
#property  indicator_width3  2
#property  indicator_width5  2

extern int  MomentumPeriod    = 14;
extern int  MaPeriod          = 14;
extern int  MaMode            = MODE_SMA;
extern int  Price             = PRICE_CLOSE;
extern bool Normalize         = false;
extern int  NormalizingPeriod = 14;

//
//
//
//
//

double osc[];
double oscUu[];
double oscUd[];
double oscDd[];
double oscDu[];
double slope[];
double ma[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,oscUu);  SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,oscUd);  SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,oscDd);  SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,oscDu);  SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,osc);
   SetIndexBuffer(5,slope);
   SetIndexBuffer(6,ma);

   string add = ""; if (Normalize) add = "Normalized ";   
   IndicatorShortName(add+"MA momentum ("+MomentumPeriod+")");
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,counted_bars=IndicatorCounted();
      if (counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

         //
         //
         //
         //
         //

         for (i=limit; i>=0 ; i--)
         {
            double div = 1; if (Normalize) div = MathMax(iATR(NULL,0,NormalizingPeriod,i),0.000000001);
               ma[i]    = iMA(NULL,0,MaPeriod,0,MaMode,Price,i);
               osc[i]   = (ma[i]-ma[i+MomentumPeriod])/div;
               oscUu[i] = EMPTY_VALUE;
               oscUd[i] = EMPTY_VALUE;
               oscDu[i] = EMPTY_VALUE;
               oscDd[i] = EMPTY_VALUE;
               slope[i] = slope[i+1];
                  if (osc[i]>osc[i+1]) slope[i] =  1;
                  if (osc[i]<osc[i+1]) slope[i] = -1;
                  if (osc[i]>0)
                     if (slope[i]==1)
                           oscUu[i] = osc[i];
                     else  oscUd[i] = osc[i];
                  if (osc[i]<0)
                     if (slope[i]==-1)
                           oscDd[i] = osc[i];
                     else  oscDu[i] = osc[i];
         }
   return(0);
}

